<?php

// [todo] bring the settings kept in Environment Installation here
class Environment_Settings {
    const KEY_FORM_CONV_GENERAL = 'form_conversion_general';
    const KEY_FORM_CONV_DETAIL = 'form_conversion_detail';
    const KEY_FORM_CONV_APPLY = 'form_conversion_apply';
    const KEY_FORM_CONV_THANKYOU = 'form_conversion_thankyou';
    const KEY_FORM_AGREEMENT = 'form_general_agreement';
    const KEY_FORM_AGREEMENT_LABEL = 'form_general_agreement_label';
    const KEY_FORM_AGREEMENT_URL = 'form_general_agreement_url';
    const KEY_FORM_ADRESS_FORMAT = 'form_address_format';
    const KEY_APPLY_OPTIONS_STATUS = 'form_apply_options_status';
    const KEY_APPLY_LOGIN_STATUS = 'form_apply_login_status';
	const KEY_FORM_REMEMBERME = 'form_general_rememberme';
	const KEY_FORM_EMAILTYPE = 'form_general_emailtype';
	const KEY_FORM_MULTIEMAIL = 'form_general_multiemail';

    const KEY_TUTORIAL_STOP = 'tutorial_stop';
    const KEY_APPLY_FORM_CAPTCHA = 'form_apply_captcha';
    const KEY_OPENAPPLICATION_FORM_CAPTCHA = 'form_openapplication_captcha';
    const KEY_TAF_CAPTCHA = 'taf_captcha';
    const KEY_AGE_LIMIT = 'form_age_limit';
    const KEY_FORM_GENDER_UNKNOWN = 'form_gender_unknown';
    const KEY_JAS_STATUS = 'jas_captcha';
    const KEY_CLEAN_CATEGORIES = 'sync_clean';
    const KEY_SKIP_MAIN_CATEGORY = 'skip_main_category';
    const KEY_SEO_SKIP_YOAST_META = 'seo_skip_yoast_meta';
    const KEY_DEV_LOGGING = 'dev_logging';
    const KEY_RESTAPI_SYNC = 'restapisync_enabled';
    const KEY_FORM_JOBBOARD = 'jobboard_form';
	const KEY_GOOGLEFORJOBS_ENABLED = 'googleforjobs_enabled';
	const KEY_GOOGLEFORJOBS_DIRECTAPPLY = 'directapply_enabled';
	const KEY_GOOGLEFORJOBS_ORGANIZATION = 'googleforjobs_organization';
	const KEY_GOOGLEFORJOBS_LOGO = 'myprefix_image_id';


	public static function setFormConversionGeneral($conversion_general)
	{
		self::_set_setting_unique(self::KEY_FORM_CONV_GENERAL, self::strip_php_open_tag($conversion_general));
	}

	public static function getFormConversionGeneral()
	{
		return self::_setting_get(self::KEY_FORM_CONV_GENERAL);
	}

	public static function setFormConversionDetail($conversion_detail)
	{
		self::_set_setting_unique(self::KEY_FORM_CONV_DETAIL, self::strip_php_open_tag($conversion_detail));
	}

	public static function getFormConversionDetail()
	{
		return self::_setting_get(self::KEY_FORM_CONV_DETAIL);
	}

	public static function setFormConversionApply($conversion_apply)
	{
		self::_set_setting_unique(self::KEY_FORM_CONV_APPLY, self::strip_php_open_tag($conversion_apply));
	}

	public static function getFormConversionApply()
	{
		return self::_setting_get(self::KEY_FORM_CONV_APPLY);
	}

	public static function setFormConversionThankyou($conversion_thankyou)
	{
		self::_set_setting_unique(self::KEY_FORM_CONV_THANKYOU, self::strip_php_open_tag($conversion_thankyou));
	}

	public static function getFormConversionThankyou()
	{
		return self::_setting_get(self::KEY_FORM_CONV_THANKYOU);
	}


    public static function setSyncCleanEmptyCategories($status)
    {
        self::_set_setting_unique(self::KEY_CLEAN_CATEGORIES, $status);
    }

     public static function getSyncCleanEmptyCategories()
    {
        $status = self::_setting_get(self::KEY_CLEAN_CATEGORIES);
        
        if(strtolower(trim($status)) === 'on' || strtolower(trim($status)) === '1') 
            return strtolower(trim($status));
        
        return false;
    }
    
    public static function setSkipMainCategory($status) 
    {
        self::_set_setting_unique(self::KEY_SKIP_MAIN_CATEGORY, $status);
    }
    
    public static function getSkipMainCategory()
    {
        $status = strtolower(trim(self::_setting_get(self::KEY_SKIP_MAIN_CATEGORY)));
        
        if($status === 'on' || $status === '1') {
            return $status;
        }
        
        return false;
    }

	/**
	 * @since 2.20.0
	 *
	 * @param $status
	 */
    public static function setRestApiSync($status)
    {
        self::_set_setting_unique(self::KEY_RESTAPI_SYNC, $status);
    }

	/**
	 * @since 2.20.0
	 *
	 * @return bool|string
	 */
    public static function getRestApiSync()
    {
        $status = strtolower(trim(self::_setting_get(self::KEY_RESTAPI_SYNC)));

        if($status === 'on' || $status === '1') {
            return $status;
        }

        return false;
    }


	/**
	 * @since 2.20.0
	 *
	 * @param $status
	 */
	public static function setDevLogging($status)
	{
		self::_set_setting_unique(self::KEY_DEV_LOGGING, $status);
	}


	/**
	 * @since 2.20.0
	 *
	 * @return bool|string
	 */
	public static function getDevLogging()
	{
		$status = strtolower(trim(self::_setting_get(self::KEY_DEV_LOGGING)));

		if($status === 'on' || $status === '1') {
			return $status;
		}

		return false;
	}


	/**
	 * @since 2.20.1
	 *
	 * @param $status
	 */
	public static function setSkipYoastMeta($status)
	{
		self::_set_setting_unique(self::KEY_SEO_SKIP_YOAST_META, $status);
	}


	/**
	 * @since 2.20.1
	 *
	 * @return bool|string
	 */
	public static function getSkipYoastMeta()
	{
		$status = strtolower(trim(self::_setting_get(self::KEY_SEO_SKIP_YOAST_META)));

		if($status === 'on' || $status === '1') {
			return $status;
		}

		return false;
	}





	public static function setFormGenderUnknown($status)
    {
        Utils_Cache::cleanEnvironment();
        self::_set_setting_unique(self::KEY_FORM_GENDER_UNKNOWN, $status);
    }
    
    public static function getFormGenderUnknown() {
        return self::_setting_get(self::KEY_FORM_GENDER_UNKNOWN);
    }
    
    public static function getSelectedFormForJobboard() {
        return self::_setting_get(self::KEY_FORM_JOBBOARD);
    }
    
    public static function setSelectedFormForJobboard($form_id) {
        self::_set_setting_unique(self::KEY_FORM_JOBBOARD, $form_id);
    }
    
    public static function setFormGeneralAgreementUrl($url)
    {
        self::_set_setting_unique(self::KEY_FORM_AGREEMENT_URL, $url);
    }

    public static function getFormGeneralAgreementUrl()
    {
        return self::_setting_get(self::KEY_FORM_AGREEMENT_URL);
    }

    public static function setApplyFormCaptchaStatus($status) 
    {
        self::_set_setting_unique(self::KEY_APPLY_FORM_CAPTCHA, $status);
    }
    
    public static function setOpenApplicationFormCaptchaStatus($status)
    {
        self::_set_setting_unique(self::KEY_OPENAPPLICATION_FORM_CAPTCHA, $status);
    }

    public static function getApplyFormCaptchaStatus()
    {
        return self::_setting_get(self::KEY_APPLY_FORM_CAPTCHA);
    }
            
    public static function getOpenApplicationFormCaptchaStatus()
    {
        return self::_setting_get(self::KEY_OPENAPPLICATION_FORM_CAPTCHA);
    }

    public static function setTAFCaptchaStatus($status)
    {
        self::_set_setting_unique(self::KEY_TAF_CAPTCHA, $status);
    }

    public static function getTAFCaptchaStatus()
    {
        return self::_setting_get(self::KEY_TAF_CAPTCHA);
    }
    
    public static function getJASCaptchaStatus()
    {
        return self::_setting_get(self::KEY_JAS_STATUS);
    }
    
    public static function setJASCaptchaStatus($jas_captcha) 
    {
        self::_set_setting_unique(self::KEY_JAS_STATUS, $jas_captcha);
    }

    public static function setFormGeneralAgreement($agreement)
    {
       self::_set_setting_unique(self::KEY_FORM_AGREEMENT, $agreement);
    }
    
    public static function getFormGeneralAgreementLabel()
    {
        return self::_setting_get(self::KEY_FORM_AGREEMENT_LABEL);
    }
    
    public static function setFormGeneralAgreementLabel($label)
    {
        self::_set_setting_unique(self::KEY_FORM_AGREEMENT_LABEL, $label);
    }
    
    public static function getFormGeneralAgreement()
    {
        return self::_setting_get(self::KEY_FORM_AGREEMENT);
    }
    
    public static function setFormAddressFormatGeneral($format)
    {
        self::_set_setting_unique(self::KEY_FORM_ADRESS_FORMAT, $format);
    }
    
    public static function getFormAddressFormatGeneral()
    {
        return self::_setting_get(self::KEY_FORM_ADRESS_FORMAT);
    }
    
    public static function setAgeLimit($age)
    {
        self::_set_setting_unique(self::KEY_AGE_LIMIT, $age);
    }
    
    public static function getAgeLimit()
    {
        return self::_setting_get(self::KEY_AGE_LIMIT);
    }
    
    public static function getFormApplyOptionsStatus()
    {
		return "off";
        // return self::_setting_get(self::KEY_APPLY_OPTIONS_STATUS);
    }
    
    public static function setFormApplyOptionsStatus($status)
    {
		$status = "off";
        self::_set_setting_unique(self::KEY_APPLY_OPTIONS_STATUS, $status);
    }
    
    public static function getLoginLinkStatus()
    {
		return "on"; // means don't show login link
//         return self::_setting_get(self::KEY_APPLY_LOGIN_STATUS);
    }
    
    public static function setLoginLinkStatus($status)
    {
	    $status = "on";
        self::_set_setting_unique(self::KEY_APPLY_LOGIN_STATUS, $status);
    }

    public static function getFormRememberMe()
    {
	    $remove_rememberme = self::_setting_get(self::KEY_FORM_REMEMBERME);
	    return !empty($remove_rememberme) ? $remove_rememberme : "off";
    }

    public static function setFormRememberMe($status)
    {
        self::_set_setting_unique(self::KEY_FORM_REMEMBERME, $status);
    }

    public static function getFormRemoveEmailType()
    {
	    $remove_emailtype = self::_setting_get(self::KEY_FORM_EMAILTYPE);
        return !empty($remove_emailtype) ? $remove_emailtype : "off";
    }

    public static function setFormEmailType($status)
    {
        self::_set_setting_unique(self::KEY_FORM_EMAILTYPE, $status);
    }

    public static function getFormRemoveMultiEmail()
    {
	    $remove_multiemail = self::_setting_get(self::KEY_FORM_MULTIEMAIL);
        return !empty($remove_multiemail) ? $remove_multiemail : "off";
    }

    public static function setFormMultiEmail($status)
    {
        self::_set_setting_unique(self::KEY_FORM_MULTIEMAIL, $status);
    }

    public static function setStopTutorial()
    {
        self::_set_setting_unique(self::KEY_TUTORIAL_STOP, Carerix::VERSION);
    }
    
    public static function getStopTutorial()
    {
        $tutorialStatusVersion = self::_setting_get(self::KEY_TUTORIAL_STOP);
        
        if($tutorialStatusVersion != Carerix::VERSION) return false;
        
        return true;
    }
    
    public static function _setting_get($setting_key)
    {
        $settingsTable = new WP_Table(Environment_Installation::TABLE_SETTINGS);
	    /** @noinspection PhpUndefinedMethodInspection */
	    $agreementRow = $settingsTable->getByKey($setting_key);

        if(count($agreementRow) > 0)
		{
			return $agreementRow[0]['value'];
		}
		
		return '';
    }
    
    public static function _setting_exists($setting_key)
    {
        $settingsTable = new WP_Table(Environment_Installation::TABLE_SETTINGS);
	    /** @noinspection PhpUndefinedMethodInspection */
	    $agreementRow = $settingsTable->getByKey($setting_key);
        if(count($agreementRow) > 0)
		{
			return (int)$agreementRow[0]['id'];
		}
		
		return FALSE;
    }
    
    public static function _set_setting_unique($key, $value)
    {
        $settingsTable = new WP_Table(Environment_Installation::TABLE_SETTINGS);
        $data = array();
        $data['value'] = $value;
        $data['key'] = $key;

        if(FALSE === $setting_id = self::_setting_exists($key))
        {
            $setting_id = $settingsTable->insert($data);
        }
        else
        {
            $settingsTable->update($setting_id, $data);
        }
        return $setting_id;
    }

    public static function getAppName() {
        return Environment_Installation::getAppName();
    }
    
    public static function getAppToken() {
        return Environment_Installation::getAppToken();
    }

    public static function getAppReporting() {
        return Environment_Installation::getAppReporting();
    }

	public static function setAppName($appName) {
        self::_set_setting_unique('app_name', $appName);
    }

    public static function setAppToken($appToken) {
        self::_set_setting_unique('app_token', $appToken);
    }
    
    public static function setAppReporting($appReporting) {
        self::_set_setting_unique('app_reporting', $appReporting);
    }

    public static function lockTheCron() {
        self::_set_setting_unique('cron_locked', 'yes');
    }
    
    public static function unlockTheCron() {
        self::_set_setting_unique('cron_locked', 'no');
    }
    
    public static function isTheCronLocked() {
        $status = trim(self::_setting_get('cron_locked'));
        
        if($status == 'yes') return true;
        return false;
    }

	/**
	 * Get client ID from Google Analytics cookie "_ga"
	 * This method is used when a client-side javascript call can't access this data
	 *
	 * @since   2.15.0         First time this was introduced
	 * @return  string|null     The client-ID or void
	 */
	public static function getGaClientId() {
		// Check for cookie
		$GA = Carerix\Cookie\Cookie::getCookie("_ga");
		if (!isset($GA)) {
			return null;
		}

		// Parse cookie _ga='<something>.<something>.<clientid>.<timestamp>';
		return explode(".", $GA)[2];
	}
    
	/**
	 * Get client ID including timestamp from Google Analytics cookie "_ga"
	 * This method is used when a client-side javascript call can't access this data
	 *
	 * @since   2.15.0          First time this was introduced
	 * @return  string|null     The client-ID + timestamp, or void
	 */
	public static function getGaClientIdWithTimestamp() {
		// Check for cookie
		$GA = Carerix\Cookie\Cookie::getCookie("_ga");
		if (!isset($GA)) {
			return null;
		}

		// Parse cookie _ga='<something>.<something>.<clientid>.<timestamp>';
		return explode(".", $GA)[2] . "." . explode(".", $GA)[3];
	}

	/**
	 *
	 * @since 2.14.47
	 */
	public static function getGoogleforjobsStatus()
	{
		$status = strtolower(trim(self::_setting_get(self::KEY_GOOGLEFORJOBS_ENABLED)));
		if($status === 'on' || $status === '1') {
			return $status;
		}

		return false;
	}

	/**
	 * @param $status
	 *
	 * @since 2.14.47
	 */
	public static function setGoogleforjobsStatus($status) {
		self::_set_setting_unique(self::KEY_GOOGLEFORJOBS_ENABLED, $status);
	}


	/**
	 *
	 * @since 2.22.0
	 */
	public static function getGoogleforjobsDirectApplyStatus()
	{
		$status = strtolower(trim(self::_setting_get(self::KEY_GOOGLEFORJOBS_DIRECTAPPLY)));
		if($status === 'on' || $status === '1') {
			return $status;
		}

		return false;
	}

	/**
	 * @param $status
	 *
	 * @since 2.22.0
	 */
	public static function setGoogleforjobsDirectApplyStatus($status) {
		self::_set_setting_unique(self::KEY_GOOGLEFORJOBS_DIRECTAPPLY, $status);
	}



	public static function setGoogleforjobsOrganization($hiring_organization)
	{
		self::_set_setting_unique(self::KEY_GOOGLEFORJOBS_ORGANIZATION, $hiring_organization);
	}

	public static function getGoogleforjobsOrganization()
	{
		return self::_setting_get(self::KEY_GOOGLEFORJOBS_ORGANIZATION);
	}

	public static function setGoogleforjobsLogo($image_id)
	{
		self::_set_setting_unique(self::KEY_GOOGLEFORJOBS_LOGO, $image_id);
	}

	public static function getGoogleforjobsLogoId()
	{
		return self::_setting_get(self::KEY_GOOGLEFORJOBS_LOGO);
	}

	public static function getGoogleforjobsLogoUrl()
	{
		$image_id = self::_setting_get(self::KEY_GOOGLEFORJOBS_LOGO);
		$image = wp_get_attachment_image_src( $image_id, 'medium');
		return $image;
	}

	public static function strip_php_open_tag($str){
		$str=preg_replace('/<\?php/i', '', $str);
		$str=preg_replace('/<\?/i', '', $str);
		return $str;
	}

}