<?php
/**
 * Renders the appy form initated by the shortcode [cx_apply_form]
 *
 * @category shortcode
 * @author Ruben Waitz
 * @link http://www.carerix.com
 * @since Oct 7, 2021
 * @version $Rev$
 */

class Frontend_Shortcode_ApplyForm extends Frontend_Shortcode_OpenForm {
	/**
	 * @param $params
	 *
	 * @return string
	 */
	public function run( $params )
	{
		$this->params = (array) $params;

		$interfacer  = WP_Interfacer::getInstance();
		$properties  = $interfacer->entity_get_properties(get_the_ID());
		$pub_id      = $properties['guid'][0];
		$jobFrontend = new Frontend_Job($properties);
		$form_id     = $jobFrontend->getFormIdFromJobSource();

		if ($form_id > 0) {
			$this->params[self::pub_id_param] = $pub_id;
			$this->params[self::form_id_param] = $form_id;
//			$info = "<div>pubID: {$pub_id}, formID: {$form_id}</div>";
			return /*$info .*/ parent::run( $this->params );
		} else {
			return '<span style="color: red;"> There is no form in the database </span>';
		}
	}
}