<?php

use Carerix\Api\Rest\Entity\CRPublication;

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Sep 3, 2013 4:27:07 PM
 * @version $Rev$
 */

class Frontend_Shortcode_Job {
    private $interfacer = null;

    public function __construct() {
        $this->interfacer = WP_Interfacer::getInstance();
    }
    
    public function rss_for_category() {
        global $post;
        if(    $this->interfacer->frontend_displayed_single() === FALSE
			&& $this->interfacer->frontend_displayed_page() === FALSE
            || $post->post_type == 'page')
		{
			return;
		}
        ob_start();
        
        $labels = Utils_Labels::get();
        $category = get_the_category();
        $category_name = '';
        $term_id = 0;

        if(isset($category[0])) {
            $term = $category[0];
            $term_id = $term->term_id;
            $category_name = $term->name ;
        }

        $feedgeneral = get_category_feed_link($term_id);

        $div = "<div class='rss'><a id='carerix_rss_link' target='_blank' rel='nofollow' href='{$feedgeneral}'>{$labels['CxPortal.message.field.rss']} $category_name</a></div>";
        echo $div;
        
        // $out = ob_get_contents();
        $out = ob_get_clean();
        return $out;
    }

    public function rss_for_all() {
        global $post;
        if(    $this->interfacer->frontend_displayed_single() === FALSE
			&& $this->interfacer->frontend_displayed_page() === FALSE
            || $post->post_type == 'page')
		{
			return;
		}
        ob_start();
        $labels = Utils_Labels::get();
        $categoryLanguage = $this->interfacer->language_major_current();
        $resource = 'resource_category_'. str_replace('.', '_', 'general.header.publications');
        $categoryKey = Environment_Settings::_setting_get($resource . '_' . $categoryLanguage);

        if(!$categoryKey) $categoryKey = $labels[$resource];
        $term = get_term_by('name', $categoryKey, 'category');

        if($term === false) {
            $terms = get_the_category();
            foreach($terms as $_term) {
                if($_term->category_parent === 0) {
                    $term = $_term;
                    break;
                }
            }
        }
        
        $url = get_category_feed_link(@$term->term_id);

        $div = "<div class='rss_all'><a id='carerix_rss_link_all' target='_blank' rel='nofollow' href='$url'>{$labels['CxPortal.message.field.rssAll']}</a></div>";
        echo $div;
        
        // $out = ob_get_contents();
        $out = ob_get_clean();
        return $out;
    }
    
    public function tell_a_friend_link() {
        global $post;
        if(    $this->interfacer->frontend_displayed_single() === FALSE
			&& $this->interfacer->frontend_displayed_page() === FALSE
            || $post->post_type == 'page')
		{
			return;
		}
        ob_start();
        $labels = Utils_Labels::get();
        $link = $this->interfacer->get_post_permalink(false, 'tellafriend');
        
        $div = "<div class='tell_a_friend'><a id='carerix_tellafriend_link' rel='nofollow' href='$link'>{$labels['CxPortal.header.tellAFriendTitle']}</a></div>";

		echo $div;
        // $out = ob_get_contents();
        $out = ob_get_clean();
        return $out;
    }
    
    public function print_link() {
        global $post;
        if(    $this->interfacer->frontend_displayed_single() === FALSE
			&& $this->interfacer->frontend_displayed_page() === FALSE
            || $post->post_type == 'page')
		{
			return;
		}
        ob_start();
        $labels = Utils_Labels::get();
        $div = "<div class='print'><a id='carerix_print_link' rel='nofollow' href='#' onclick='window.print();  '>{$labels['general.button.print']}</a></div>";	
        echo $div;
        // $out = ob_get_contents();
        $out = ob_get_clean();
        return $out;
    }

	/**
	 * Vacancy Number
	 * Internal CX fieldname: vacancyID
	 *
	 * @return false|string|void
	 */
    public function vacancy_number() {
        global $post;
        if(    $this->interfacer->frontend_displayed_single() === FALSE
			&& $this->interfacer->frontend_displayed_page() === FALSE
            || $post->post_type == 'page')
		{
			return;
		}
        ob_start();
        $labels = Utils_Labels::get();
        $post_id = $post->ID;
        $interfacer = WP_Interfacer::getInstance();
        $props = $interfacer->entity_get_properties($post_id);
        $vacancyID = (string)$props['vacancyID'][0];
        
        $div = "<div id='carerix_vacancy_id'><strong>{$labels['general.header.jobID']}:</strong> #{$vacancyID} </div>";
        echo $div;
        // $out = ob_get_contents();
        $out = ob_get_clean();
        return $out;
    }

 	/**
	 * Vacancy reference code
	 * Internal CX fieldname: vacancyNo
	 *
	 * @return string
	 */
    public function vacancy_code() {
	    return get_post_meta(get_the_ID(), 'vacancyNo', true);
    }

    public function social_icons() {
        global $post;
        if(    $this->interfacer->frontend_displayed_single() === FALSE
			&& $this->interfacer->frontend_displayed_page() === FALSE
            || $post->post_type == 'page')
		{
			return;
		}
        ob_start();
        $div = "<div class='social_icons'>
						<div id='cx_socials'>
							<span class='st_facebook' ></span><span class='st_twitter' ></span>					
                            <span class='st_linkedin' ></span><span class='st_email' ></span>
						</div>
                        <script type='text/javascript'>var switchTo5x=true;</script>
						<script type='text/javascript' src='https://ws.sharethis.com/button/buttons.js'></script>
                        <script type='text/javascript'>stLight.options({publisher: '9b61bbc7-5b60-40a2-9ea9-36c8b84e5406', doNotHash: false, doNotCopy: false, hashAddressBar: false});</script>
						
                    </div>";
        echo $div;
        // $out = ob_get_contents();
        $out = ob_get_clean();
        return $out;
    }
    
    public function apply_button() {
        global $post;
        if(    $this->interfacer->frontend_displayed_single() === FALSE
			&& $this->interfacer->frontend_displayed_page() === FALSE
            || $post->post_type == 'page')
		{
			return;
		}
        $labels = Utils_Labels::get();
        $post_permalink = $this->interfacer->get_post_permalink(false, 'apply=true');
        return "<div><a id='apply_button' class='cx2_vacancydetails-apply' href='$post_permalink'>{$labels['general.button.apply']}</a></div>";
    }
    
    public function job_alert_subscription_link() {
        global $post;
        if(    $this->interfacer->frontend_displayed_single() === FALSE
			&& $this->interfacer->frontend_displayed_page() === FALSE
            || $post->post_type == 'page')
		{
			return;
		}
        ob_start();
        $link = $this->interfacer->get_post_permalink(false, 'subscribe');
        $labels = Utils_Labels::get();
        $div = "<div class='apply'><a id='carerix_jas_link' rel='nofollow' href='$link'>{$labels['general.button.subscribeJobAlert']}</a></div>";	
        echo $div;
        // $out = ob_get_contents();
        $out = ob_get_clean();
        return $out;
    }
    
    public function function_group() {
        global $post;
        if(    $this->interfacer->frontend_displayed_single() === FALSE
			&& $this->interfacer->frontend_displayed_page() === FALSE
            || $post->post_type == 'page')
		{
			return;
		}
        ob_start();
        
        $post_id = $post->ID;

        $interfacer = WP_Interfacer::getInstance();
        $props = $interfacer->entity_get_properties($post_id);
        $pubKey = '_carerix_job';
        if($this->interfacer->wpml_is_active()) {
            $pubKey .= '_'.$this->interfacer->language_major_current();
        }
        
        $pubID = (string)$props[$pubKey][0];
        
        if($pubID) {
            $params = array('show' => array('toVacancy', 'toVacancy.toFunctionLevel1.value','toVacancy.toFunctionLevel2.value','toVacancy.toFunctionLevel3.value', 'publicationID') );

            $publication = CRPublication::find($pubID, $params);
            $labels = Utils_Labels::get();

            $functionGroup = implode(' / ', array_filter(array(
                            $publication->toVacancy->toFunctionLevel1->value,
                            $publication->toVacancy->toFunctionLevel2->value,
                            $publication->toVacancy->toFunctionLevel3->value
                        )));
            $div = '';
            if($functionGroup) $div = "<div id='carerix_function_group'><strong>{$labels['CxPortal.message.field.functionGroup']}:</strong> $functionGroup</div>";
            echo $div;
        }
        
        // $out = ob_get_contents();
        $out = ob_get_clean();
        return $out;
    }
    
    public function brief_section() { }
    
//    static function get_source_data() {
//        global $post;
//        if(    $this->interfacer->frontend_displayed_single() === FALSE
//			&& $this->interfacer->frontend_displayed_page() === FALSE
//            || $post->post_type == 'page')
//		{
//			return;
//		}
//
//        $post_id = $post->ID;
//        $interfacer = WP_Interfacer::getInstance();
//        $props = $interfacer->entity_get_properties($post_id);
//        $source_id = (string)$props['source'][0];
//        $source = Table_Source::get();
//        $source_data = $source->getByID($source_id);
//        $source_data['settings'] = unserialize($source_data['settings']);
//        return $source_data;
//    }

}