cx = (function () {
    var publicationID, vacancyID, title, gaClientID, gaClientIDWithTimestamp, applySource, applyTags;

    function __getApplySource( applySource2 ) {
        if ( applySource2 ) return applySource2; // Fix to return cookie in current request
        return getCookie("cx_applysource");
    }

    function __getApplyTags( applyTags2 ) {
        if ( applyTags2 ) return applyTags2; // Fix to return cookie in current request
        return getCookie("cx_applytags");
    }

    function setCookie(cname,cvalue,exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays*24*60*60*1000));
        var expires = "expires=" + d.toGMTString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }

    function getCookie(cname) {
        var name = cname + "=";
        var decodedCookie = decodeURIComponent(document.cookie);
        var ca = decodedCookie.split(';');
        for(var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') {
                c = c.substring(1);
            }
            if (c.indexOf(name) == 0) {
                return c.substring(name.length, c.length);
            }
        }
        return "";
    }

    return { // public interface
        setPublicationID: function(value) {
            publicationID = value;
            this.publicationID = value;
        }
        ,
        getPublicationID: function() {
            return publicationID;
        }
        ,
        publicationID: publicationID
        ,
        setVacancyID: function(value) {
            vacancyID = value;
            this.vacancyID = value;
        }
        ,
        getVacancyID: function() {
            return vacancyID;
        }
        ,
        vacancyID: vacancyID
        ,
        setTitle: function(value) {
            title = value;
            this.title = value;
        }
        ,
        getTitle: function() {
            return title;
        }
        ,
        title: title
        ,
        setGaClientID: function(value) {
            gaClientID = value;
            this.gaClientID = value;
        }
        ,
        getGaClientID: function() {
            return gaClientID;
        }
        ,
        gaClientID: gaClientID
        ,
        setGaClientIDWithTimestamp: function(value) {
            gaClientIDWithTimestamp = value;
            this.gaClientIDWithTimestamp = value;
        }
        ,
        getGaClientIDWithTimestamp: function() {
            return gaClientIDWithTimestamp;
        }
        ,
        gaClientIDWithTimestamp: gaClientIDWithTimestamp
        ,
        setApplySource: function(value) {
            setCookie("cx_applysource", value, 30);
            applySource = value;
            this.applySource = value;
        }
        ,
        getApplySource: function() {
            return __getApplySource(applySource);
        }
        ,
        applySource: __getApplySource(applySource)
        ,
        setApplyTags: function(value) {
            setCookie("cx_applytags", value, 30);
            applyTags = value;
            this.applyTags = value;
        }
        ,
        getApplyTags: function() {
            return __getApplyTags(applyTags);
        }
        ,
        applyTags: __getApplyTags(applyTags)
    };
})();


carerix_jQuery(document).ready(function(e){
    var $ = carerix_jQuery;
    var guid = (function() {
        function s4() {
            return Math.floor((1 + Math.random()) * 0x10000)
                     .toString(16)
                     .substring(1);
        }
            
        return function() {
            return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
               s4() + '-' + s4() + s4() + s4();
        };
    })();
  
    $('select.carerix_input').change(function(e){
        var self = this;
        var affects = $(self).data('affects');

        if(affects) {
            _hide_chain(self);
            var spinner = $(self).parent().find('.wait');
            spinner.fadeIn();
            
            var parentElement = $(self).parents('div.selector_chain_holder');

            var affectedElement = $(parentElement).find( "select[data-id='" + affects + "']" );

            var parent = $(self).find(':selected').val();
            if(!parent) {
                parent = $(self).attr('data-should_select');
            }
            var table = $(affectedElement).data('table');

            var data = {
                action: 'get_items',
                parent: parent,
                table: table
            };
            
            $.post(ajaxurl, data, function(response, status, jqXHR){
                spinner.fadeOut();
                var html = '<option value=""></option>';
                
                if(response.length === 0) {
                    _hide_chain(affectedElement);
                } else {
                    $(affectedElement).parent().fadeIn();
                    $(affectedElement).fadeIn();
                }
                
                var gotSelected = false;
                var shouldSelect = $(affectedElement).data('should_select');
                for(var i =0; i < response.length; i++) {
                    var selected = '';
                    if(shouldSelect == response[i].value) {
                        gotSelected = true;
                        selected = 'selected';
                    }
                    html += "<option value='"+response[i].value+"' " + selected +" >"+response[i].label+"</option>";
                }
                $(affectedElement).html(html);
                if(gotSelected) {
                   $(affectedElement).trigger('change');
                }
            }, 'json');
        }
        
    });
    
    function _hide_chain(startElement, self) {
        if(self) {
            $(startElement).fadeOut();
            $(startElement).parent().fadeOut();
        }
        var selfName = $(startElement).data('id');
        var parentElement = $(startElement).parents('div.selector_chain_holder');
        var affectedElement = null;
            
        var selects = $(parentElement).find('select');
        $.each(selects, function(select){
            var affectedBy = $(this).attr('data-affectedby');
            if(affectedElement === null && affectedBy == selfName) {
                affectedElement = $(this);
            }
        });
        if(affectedElement) {
            _hide_chain(affectedElement, true);
        }
    }
    
    $('.repeat').click(function(e){
        e.preventDefault();
       var self = this; 
       var old_index = $(self).data('index');
       var clas_ = '.data_' + old_index;
       var last = $('div'+clas_).last();
       if(last) {
           var clone = last.clone(true);
           var cloned_input = clone.find('.carerix_input');
           cloned_input.removeClass('carerix_required');
           var clonedRadios = $(clone).children().find('input[type="radio"]');
           $(clonedRadios).each(function(index, element){
               var oldName = $(element).attr('name');
               var _ni = oldName.substring(oldName.lastIndexOf('[')+1, oldName.lastIndexOf(']'));
               var newIndex = parseInt(_ni) + 1;
               var relatedIndex = $(this).parent().find('.related_index');
               $(relatedIndex).val(newIndex);
               var newName = oldName.substring(0, oldName.lastIndexOf('[')) + '[' + newIndex + ']';
               $(element).attr('name', newName);
               $(element).prop('checked', false);
           });
           clone.find('.remove_on_clone').remove();
           if($(cloned_input).hasClass('transform_to_file')) {
               $(cloned_input).attr('type', 'file');
           }
           $(cloned_input).removeAttr('disabled');
           $(cloned_input).removeAttr('readonly');
           $(cloned_input).val('');
           $(cloned_input).attr('id', guid());
           clone.hide();
           clone.insertAfter(last);
           clone.fadeIn();
       }
       if($('div'+clas_).length > 1) {
           $('.derepeat'+clas_).each(function(){
                var parent = $(this).parent();
                var requiredInputs = $(parent).find('.carerix_required');
                if(requiredInputs.length === 0) {
                    $(this).fadeIn();
                }
           });
       }
       
       if($(self).hasClass('personal-coverLetter')) {
            var removeButtons = $('.derepeat.personal-coverLetter').length;
            if(removeButtons >= 5) {
                $('.repeat.personal-coverLetter').hide();
            }
        }
       
       return false;
    });
    
    $('.derepeat').click(function(e){
        e.preventDefault();
        var self = this;
        var removes = $(self).attr('data-index');
        var related = $(self).attr('data-remove');
        var element = $(self).parents('.data_'+removes);
        if(element.length === 1) {
            var requiredInputs = $(element).find('.carerix_required');
            if(requiredInputs.length === 0) {
                $(element).remove();
            }
        }
        
        var relatedRemoveButtons = $('.derepeat.'+related);
        if(relatedRemoveButtons.length <= 1) {
            $('.derepeat.'+related).hide();
        }
        if($(self).hasClass('personal-coverLetter') && relatedRemoveButtons.length < 5) {
            $('.repeat.personal-coverLetter').show();
        }
        
    });
    
    $('#agreement').click(function(e){
       e.preventDefault();
       return false;
    });
    
    $('.close_modal_carerix').click(function(e){
        $('#agreement').hide();
        $('#carerix_modal').remove();
    });
    
    $('#show_agreement').click(function(e){
       e.preventDefault();
       if($('#agreement').length) {
           var $modal = $('<div id="carerix_modal"></div>');
           $modal.appendTo(document.body);
           $modal.css({
                'height': '100%',
                'width': '100%',
                'background-color': 'rgb(0, 0, 0)',
                'opacity': '0.6',
                'position': 'fixed',
                'left': '0px',
                'top': '0px',
                'z-index': '89999990'});
            $('#agreement').css({
                'position': 'fixed',
                'left': '25%',
                'top': '25%',
                'z-index': '89999991',
                'padding': '20px',
                'background-color': 'white',
                'height' : '50%',
                'width' : '50%',
                'overflow' : 'auto'
            });
            $('#agreement').appendTo(document.body);
            $('#agreement').show();
       }
       
       return false;
    });
    
    $('#apply_button, #subscribe_button').click(function(e){
        var jqVersion = parseInt(jQuery().jquery);

        if($('#apply_form form').length || $('#subscribe_form').length) {
            e.preventDefault();
        }
        var foundError = false;
        $('#agreement_container .error').remove();
        if($('#agreement_check').length > 0 && !$('#agreement_check').is(':checked'))
        {
            foundError = true;
            $("<div class='error'>"+fieldIsRequiredMessage+"</div>").appendTo('#agreement_container');
        }


        // Validate required fields
        $('.carerix_required').each(function(index, object){
           $(object).parent().find('.error').remove();
           var value = $(object).val();
           if (value) {
               value = value.trim();
           }

           if ( value === '' && $(object).parent().css('display') !== 'none' || ( $(object).attr('id') === 'personal-password' && value == '******') ) {
                foundError = true;
                $("<div class='error'>"+fieldIsRequiredMessage+"</div>").appendTo($(object).parent());
           }
        });


        // Validate contents of email fields
        jQuery('input[type=email].carerix_input').each(function(index, object) {
            if (jqVersion >= 3) {
                var value = $(object).val();
                if (value) {
                    value = value.trim();
                }
                var EmailRegex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
                if (value !== '' && EmailRegex.test(value) == false) {
                    jQuery(object).parent().find('.error').remove();
                    foundError = true;
                    jQuery("<div class='error'>"+fieldMandatoryEmailMessage+"</div>").appendTo($(object).parent());
                }
            } else {
                try {
                    var errorMessage = jQuery(object).getErrorMessage(); // using jQuery.webshims
                    if (errorMessage) {
                        jQuery(object).parent().find('.error').remove();
                        foundError = true;
                        jQuery("<div class='error'>" + errorMessage + "</div>").appendTo(jQuery(object).parent());
                    }
                } catch(err) {
                    console.log("Error using webshims libs. Make sure caching plugins like Autoptimize are correctly configured and compatible!");
                }
            }
        });


        if($("#personal-birthDate").val() && $("#personal-birthDate").val() != '') {
            var dateString = $("#personal-birthDate").val();
            var birthday = +new Date(dateString);
            var age = ~~((Date.now() - birthday) / (31557600000));
            var object = $("#personal-birthDate");
            if(age < window.carerix_age_limit) {
                $(object).parent().find('.error').remove();
                foundError = true;
                $("<div class='error'>"+window.carerix_age_limit_message+"</div>").appendTo($(object).parent());   
            }
        }
        
        if(!foundError) {
            if($('#apply_form form')) {
                 $('#apply_form form').submit();
            }
            if($('#subscribe_form form')) {
                $('#subscribe_form form').submit();
            }
        } else {
            var firstError = $('.error').first();
            var offset = $(firstError).offset();
            offset.left -= 40;
            offset.top -= 40;
            $('html, body').animate({
                scrollTop: offset.top,
                scrollLeft: offset.left
            });
        }
        if($('#apply_form form').length || $('#subscribe_form').length) {
           return false;
        }
    });
    
    $('#personal-password').click(function(e){
       if($(this).val() == '******') {
           $(this).val('');
       }
    });
    
    $('.block-repeat').click(function(e){
        e.preventDefault();
        var repeat_class = $(this).attr('data-repeatclass');
        var selector = 'div.' + repeat_class;
        var toClone = $(selector).first().clone(true);
        
        // @todo: clean selected options and filled inputs;
        var inputs = toClone.find('input');
        $.each(inputs, function(input) {
            $(this).val('');
        });
        
        $(toClone).find('script').remove();
        
        var selects = toClone.find('select');
        $.each(selects, function(index, select) {
            var affectedBy = $(select).attr('data-affectedby');
            if(index > 0 && affectedBy) {
                $(select).html('');
            }
            $(select).attr('id', uniqid());
            
            $(select).prop('selectedIndex', -1);
            $(select).data('should_select', '');
            $(select).removeAttr('data-should_select');
            var options = $(select).find('option');
            $.each(options, function(index, option){
                $(option).removeAttr('selected');
            });
            
            if(affectedBy) {
                $(select).hide();
            }
        });
        
        toClone.insertAfter($(selector).last());
        
        setTimeout(function(){
            var firstSelector = toClone.find('select').first();
            var firstSelectorOptions = $(firstSelector).find('option');
            if(firstSelectorOptions.length == 2) {
                if($(firstSelectorOptions[0]).val() == '') {
                    $(firstSelectorOptions[1]).attr('selected','selected');
                    $(firstSelector).attr('data-should_select', $(firstSelectorOptions[1]).val());
                    $(firstSelector).trigger('change');
                }
            }

            if($(selector).length >= 2 ) {
                $(selector + ' .block-derepeat').fadeIn();
            }
        }, 500);
        
        return false;
    });
    
    $('.block-derepeat').click(function(e){
        e.preventDefault();
        var self = this;
        var repeat_class = $(self).attr('data-repeatclass');
        var selector = 'div.' + repeat_class;
        
        var parent = $(self).parents(selector);
        $(parent).fadeOut(function(){
            $(parent).remove();
            var removeButton = $('.block-derepeat.'+repeat_class);
            if(removeButton.length < 2) {
                removeButton.hide();
            }
        });
        
        return false;
    });
    
    function uniqid(prefix, more_entropy) {
        if (typeof prefix === 'undefined') {
          prefix = '';
        }

        var retId;
        var formatSeed = function(seed, reqWidth) {
          seed = parseInt(seed, 10)
            .toString(16); // to hex str
          if (reqWidth < seed.length) { // so long we split
            return seed.slice(seed.length - reqWidth);
          }
          if (reqWidth > seed.length) { // so short we pad
            return Array(1 + (reqWidth - seed.length))
              .join('0') + seed;
          }
          return seed;
        };

        // BEGIN REDUNDANT
        if (!this.php_js) {
          this.php_js = {};
        }
        // END REDUNDANT
        if (!this.php_js.uniqidSeed) { // init seed with big random int
          this.php_js.uniqidSeed = Math.floor(Math.random() * 0x75bcd15);
        }
        this.php_js.uniqidSeed++;

        retId = prefix; // start with prefix, add current milliseconds hex string
        retId += formatSeed(parseInt(new Date()
          .getTime() / 1000, 10), 8);
        retId += formatSeed(this.php_js.uniqidSeed, 5); // add seed hex string
        if (more_entropy) {
          // for more entropy we add a float lower to 10
          retId += (Math.random() * 10)
            .toFixed(8)
            .toString();
        }

        return retId;
      }
});
