<?php
$ajax_nonce_synchronize_single_source  = wp_create_nonce( "synchronize_single_source" );
$ajax_nonce_save_source  = wp_create_nonce( "save_source" );
?>
<form method="post" class="undoable">
<?php wp_nonce_field('source_edit', '_carerix_nonce_field'); ?>
<?php $action = isset($edit_data['id']) ? "edit" : "new"; ?>
<input type="hidden" value="<?php echo @$edit_data['id']; ?>" name="id" id="source_id">
	
<div class="wrap">
	<div id="icon-edit-pages" class="icon32 icon32-posts-page"><br></div>

	<h2><?php echo $action=="new" ? "Add New" : "Edit"; ?> Jobs Source</h2>
	
    <div class="carerix_msgBox carerix_error" id="sync_error_message" style="display: none;" >
        The Jobs feed can not be reached on <?php echo Environment_Installation::getAppName(); ?>.carerix.com/cxtools . Check that the application name was correctly set. If the problem persists please inform your Carerix Administrator 
    </div>

    <div class="carerix_msgBox carerix_ok" id="half_success_message" style="display: none;">
        The Jobs source was successfully saved<?php /*, but there where no publications available for this source */?>.
    </div>
	
    <div class="carerix_msgBox carerix_ok" id="success_message" style="display: none;">
        The Jobs source was successfully saved. 
        <?php if(@$edit_data['id']): ?>
            The page <a id="page_link" href="" target="_blank"><span id="page_title"></span></a> was updated.
        <?php else: ?>
            The page <a id="page_link" href="" target="_blank"><span id="page_title"></span></a> was created.
        <?php endif; ?>

    </div>
	
	
	<div class="carerix_msgBox carerix_note">
        Enter the name of the source and click Save. Optionally you can add more parameters to the feed source.
    </div>


	<div id="poststuff">

		<div id="post-body" class="metabox-holder columns-2">

			<div id="post-body-content">
				<div id="titlediv">
					<div id="titlewrap">
						<h2>Source Name</h2>
						<input type="text" name="name" value="<?php echo @$edit_data['name']; ?>" size="30" id="title" autocomplete="off" class="<?php if(@$title_error) echo "carerix_field_error"; ?>">
                        <p class="carerix_field_error" style="display: none;" id="title_error_message">The page name is mandatory</p>
					</div>
				</div>
			</div>

            <div class="postbox-container">
                <div class="postbox">
                    <h2>Publication Details Options</h2>
                    <div class="inside">
                        <table id="newmeta">
                            <tbody>
                            <tr>
                                <td style="vertical-align: middle; padding-right: 16px;">
                                    Apply form to use
                                </td>
                                <td>
                                    <select name="apply_form">
						                <?php foreach ($apply_forms as $apply_form): ?>
							                <?php $selected = ($apply_form['id'] == @$edit_data['settings']['apply_form']) ? "selected" : ""; ?>
							                <?php echo "<option $selected value='{$apply_form['id']}' >{$apply_form['name']}</option>"; ?>
						                <?php endforeach; ?>
                                    </select>
                                </td>
                            </tr>
                            <tr>
                                <td style="vertical-align: middle; padding-right: 16px;">
                                    Create Post Title as
                                </td>
                                <td>
                                    <fieldset>
						                <?php
						                $selected_title_location = '';
						                $selected_title_title    = '';

						                if (!isset($edit_data['settings']['title_compose'])
							                || $edit_data['settings']['title_compose'] == 'location')
						                {
							                $selected_title_location = 'checked';
						                }
						                else
						                {
							                $selected_title_title = 'checked';
						                }
						                ?>
                                        <label for='just_title'><input id='just_title' type='radio'
                                                                       name='title_compose' <?php echo $selected_title_title; ?>
                                                                       value='title'/> Title</label>
                                        &nbsp;&nbsp;
                                        <label for='and_location'><input id='and_location' type='radio'
                                                                         name='title_compose' <?php echo $selected_title_location; ?>
                                                                         value='location'/> Title - Location</label>
                                    </fieldset>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                    </div>

                    <br style="clear: both;">

                    <h2>Set Alternative Feed Source Parameters</h2>
                    <div class="inside">
                        <div>
                            By default the medium-code `web` (own website) is used. So, all vacancies published to medium-code `web` are retrieved.<br>
                            If you publish vacancies to a different medium-code in your Carerix system, you can configure it here.<br>
                            Suppose you've setup the medium-code `mysecondbrand` with some publications running on it, you need to fill in: <code>medium=mysecondbrand</code>
                        </div>
                        <br style="clear: both;">
                        <code style="display: inline-block;"><?php echo Environment_Installation::get_publications_feed(); ?>?</code><input type="text" name="feed" size="30" autocomplete="off" placeholder="e.g: medium=mysecondbrand" style="padding: 3px 8px; font-size: 1em; display: inline-block; line-height: 100%; outline: none;" value="<?php echo @$edit_data['settings']['feed'] ; ?>">
                    </div>
                </div>
            </div>

<?php
/** @deprecated page introtext isn't used for vacancy posts rendering. It is used for rendering a "page-type post" which isn't used anymore
 *
 *
            <br style="clear: both;">
            <br style="clear: both;">

            <div class="postbox-container">
                <div class="postbox">
                    <h2>Page intro text</h2>
                    <div class="inside" >
                        <?php wp_editor( @$edit_data['settings']['introtext'], "introtext" ); ?>
                    </div>
                </div>
            </div>
*/
?>

            <br style="clear: both;">
			<br style="clear: both;">
            
            <div class="postbox-container">
                <div class="postbox">
                    <h2>Publication Details Header</h2>
                    <div class="inside" >
                        <?php wp_editor( @$edit_data['settings']['header'], "header" ); ?>
                    </div>
                </div>
            </div>


            <div class="postbox-container">
                <div class="postbox">
                    <h2>Publication Details Footer</h2>
                    <div class="inside">
                        <div>
                            Useful shortcodes:
                            <ul>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value="[cx_apply_button]" style="width: 130px; text-align: center; border: none;"> to generate an apply-button leading to the apply form
                                </li>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value="[cx_apply_form]" style="width: 130px; text-align: center; border: none;"> to generate an inline apply form
                                </li>
                            </ul>
                        </div>
			            <?php
			            /**
			             * [cx_apply_button] shortcode is not mandatory anymore in Sources->Source edit->Publication Details Footer
			             *
			             * @since 2.20.1
			             */
			            if(!isset($edit_data['settings']['footer']) || strlen(trim($edit_data['settings']['footer'])) <=0 )  :
				            if ($action == "new") {
					            $edit_data['settings']['footer'] = '[cx_apply_button]';
				            } else {
					            $edit_data['settings']['footer'] = '';
				            }
			            endif;
			            ?>

			            <?php wp_editor( @$edit_data['settings']['footer'], "footer" ); ?>
                    </div>
                </div>
            </div>

            <div>
                <div class="carerix_msgBox carerix_note">
                    The synchronization with Carerix process will start after clicking Save. This might take a few seconds. Do not close this page until the confirmation message is displayed.
                </div>
                <div id="sync_error" class="carerix_msgBox carerix_error" style="display: none;">
                    Error: the synchronization process for this Jobs source failed. Please try again. If the problem persists please contact your Carerix administrator.
                </div>
                <button name="save" id="save" class="button button-primary button-large"><i class="fa fa-refresh fa-spin wait" style="display: none;"></i> Save</button>
                <a href="<?php echo $cancel_link; ?>" class="button button-large right">Cancel</a>
            </div>

		</div>
		
	</div>
	
</div>
	
</form>

<script type="text/javascript">
    jQuery(document).ready(function(e){
        $ = jQuery;
        
        $('#brief_section').click(function(e){

            var checked = $('#brief_section').is(':checked');
            if(checked) {
                $('.brief_controlled').fadeIn();
            } else {
                $('.brief_controlled').fadeOut();
            }
        });
        
        $("#save").click(function(e){
           e.preventDefault();
           $("#sync_error").hide();
           $("#success_message").hide();
           $("#sync_error_message").hide();
           $("#title_error_message").hide();
           $('#title').removeClass('carerix_field_error');
           var self = this;
           
           var richEditors = ['header', 'footer'];

           var selector = '';
           var selectorValue = '';
           for(var i = 0; i < richEditors.length; i++) {
               selector = richEditors[i];
                if($('#'+selector).css('display') == 'none') {
                    selectorValue = tinyMCE.editors[i].getContent();
                } else {
                    selectorValue = $('#'+selector).val();
                }

                $("#"+selector).val(selectorValue);
           }
           
           var $data = $("form.undoable").serialize();
           var url = ajaxurl + '?' +$data;
           
           var spinner = $(self).find('.wait').show();
           $(self).attr('disabled', 'disabled');
           
           var data = {
               action: 'save_source',
               security: '<?php echo $ajax_nonce_save_source; ?>',
               type: 'job'
           };
           
           var stepErrors = {};
           var setStepError = function(step) {
               if(stepErrors[step]) {
                   stepErrors[step] = stepErrors[step] + 1;
               } else {
                   stepErrors[step] = 1;
               }
           };
           
           var maximumReached = function(step) {
               var max = 3;
               if(stepErrors && stepErrors[step] >= max) {
                   return true;
               }
               return false;
           };
           
           var cron = function(type, source_id, page) {
               if(maximumReached(page)) {
                   $("#sync_error").fadeIn();
                   spinner.hide();
                   $(self).removeAttr('disabled');
                   return;
               }
               
               var data = {
                 action: 'synchronize_single_source',
                 security: '<?php echo $ajax_nonce_synchronize_single_source; ?>',
                 type: type,
                 id: source_id,
                 page: page
               };
               
               $.post(ajaxurl, data, function(response, status, jqXHR) {
                   if(response && response.ok) {
                       if(response.hasMore) {
                           cron(type, source_id, page+1);
                       } else {
                           spinner.hide();
                           $(self).removeAttr('disabled');
                           // success message
                            
                            var link = response.post;
                            if(link === false) {
                                var half_success = $('#half_success_message');
                                half_success.fadeIn();
                                var offset = half_success.offset();
                                offset.left -= 40;
                                offset.top -= 40;

                            } else {
                                var success = $("#success_message");
                                success.fadeIn();
                                var offset = success.offset();
                                offset.left -= 40;
                                offset.top -= 40;
                                var title = $("#title").val();
                            
                                $("#page_link").attr('href', link);
                                $("#page_title").text(title);
                            }
                            $('html, body').animate({
                                scrollTop: offset.top,
                                scrollLeft: offset.left
                            });
                            
                            $("form.undoable").data("changed", false);
                       }
                   } else {
                       cron(type, source_id, page);
                       setStepError(page);
                   }
               }, 'json').fail(function(){
                   cron(type, source_id, page);
                   setStepError(page);
               });
           };
           
           $.post(url, data, function(response, status, jqXHR){
               //spinner.hide();
               //$(self).removeAttr('disabled');
               if(response['success']) {
                   $("#source_id").val(response["id"]);

                  cron('job', response["id"], 0);
               }

               if(response['title_error']) {
                   var title_error = $("#title_error_message");
                   title_error.fadeIn();
                   $('#title').addClass('carerix_field_error');
                   var offset = $('#title').offset();
                   offset.left -= 100;
                   offset.top -= 100;
                   
                   $('html, body').animate({
                       scrollTop: offset.top,
                       scrollLeft: offset.left
                   });
                   spinner.hide();
                   $(self).removeAttr('disabled');
               }
               
           }, 'json');
           return false;
        });
    });
</script>