<?php /** @noinspection PhpUndefinedVariableInspection */
// Used for "extra document" which can be multiple
if(!isset($id)) $id = '';
if(!isset($label)) $label = '';
if(!isset($class_chain)) $class_chain = '';
if(!isset($name)) $name = '';
if(!isset($error)) $error = '';
if(!isset($value)) $value = '';
if(!isset($repeatable)) $repeatable = '';

$isRequired = (stripos($class_chain, 'required') !== FALSE) ? true : false;
// determine required class for label tag
$req_class_label = $isRequired ? " cx2_required" : "";

$labels = Utils_Labels::get();
global $dataindex;
$dataindex++;
if (!isset($container_class)) $container_class = "cx2_" . $id; // set default div classname
$class ='data_'.$dataindex;
if (isset($container_class)) {
	$class .= ' ' . $container_class;
}

global $repeatindex;
$kept = \Carerix\Cookie\Cookie::getCookie("kept", null, true);
$exploded = explode('-', $id);
$type = $exploded[1];
$section = $exploded[0];
$on_disk_name = "{$type}_on_disk";

$repeatedItems = 0;

if ( strlen($value) ) return;


if (!function_exists("cx_init_repeatablefile_handle_footer"))
{
	function cx_init_repeatablefile_handle_footer($id, $name, $value, $class_chain)
	{
		global $CX_INIT_FILE_HANDLER_SINGLETON_IDS;
		if (!isset($CX_INIT_FILE_HANDLER_SINGLETON_IDS)) $CX_INIT_FILE_HANDLER_SINGLETON_IDS = array();

		$js = <<<EOT
    carerix_jQuery(document).ready(function(){
        var $ = carerix_jQuery;
        $('#{$id}_change').click(function(e){
            e.preventDefault();
            
            var the_id = '{$id}';
            var the_id_temp = '{$id}_temp';
            var file_input = $('<input type="hidden" name="clear[]" value="{$name}"> <input class="{$class_chain}" type="file" id="'+the_id_temp+'" data-index="0" name="{$name}" value="{$value}" />') ;

            var \$parent = $('.'+the_id+'_to_display').parent();
            \$parent.append(file_input);
            
            $('#'+the_id).remove();
            $('.'+the_id+'_to_display').remove();
            $('.'+the_id+'_on_disk').remove();
            $('#'+the_id+'_change').remove();
            $('#'+the_id_temp).attr('id',the_id);
            return false;
       });       
    });
EOT;

		if (!in_array($id, $CX_INIT_FILE_HANDLER_SINGLETON_IDS))
		{
			wp_register_script('repeatablefile-handle-footer', '', [], '', true);
			wp_enqueue_script('repeatablefile-handle-footer');
			wp_add_inline_script("repeatablefile-handle-footer", $js);
			$CX_INIT_FILE_HANDLER_SINGLETON_IDS[] = $id;
		}
	}
}


$existsFilesInSession = isset($kept[$type.'_on_disk']);

if ($existsFilesInSession) {
	$first_file = is_array($kept[$type.'_on_disk']) ? filter_var($kept[$type.'_on_disk'][0], FILTER_SANITIZE_SPECIAL_CHARS) : filter_var($kept[$type.'_on_disk'], FILTER_SANITIZE_SPECIAL_CHARS);
	$uploaded_file_another_time_in_history_path = $uploadDirPath = Carerix::$TMPDIR . DIRECTORY_SEPARATOR . Utils_Log::UPLOADS_DIR_CONTAINER . DIRECTORY_SEPARATOR . $first_file;
	if (!file_exists($uploaded_file_another_time_in_history_path)) { // The file (upload) is expired and removed from the server earlier
		$existsFilesInSession = false;
	}
}

if ($existsFilesInSession): ?>
    <?php
	    $file_count = 1;
	    $is_multi_file = is_array($kept[$type.'_on_disk']);
        if ($is_multi_file) {
            $file_count = count($kept[$type.'_on_disk']);
        }
    ?>
	<?php for($i = 0; $i < $file_count; $i++): ?>
		<?php
		$repeatedItems++;
		if ($is_multi_file) {
			$_value = filter_var($kept[$type.'_on_disk'][$i], FILTER_SANITIZE_SPECIAL_CHARS);
			$value = filter_var($kept[$type.'_to_display'][$i], FILTER_SANITIZE_SPECIAL_CHARS);

        } else {
			$_value = filter_var($kept[$type.'_on_disk'], FILTER_SANITIZE_SPECIAL_CHARS);
			$value = filter_var($kept[$type.'_to_display'], FILTER_SANITIZE_SPECIAL_CHARS);
        }
		?>
        <div class='<?php echo $class; ?>'>
            <label for="<?php echo $id; ?>" class="cx2_<?php echo $id; ?><?php echo $req_class_label; ?>"><?php echo $label; ?></label>
			<?php
			if($_value):
				$id .= '_'.  uniqid();
				?>
                <input name="<?php echo $on_disk_name; ?>[]" value="<?php echo $_value; ?>" type="hidden" class="<?php echo $id; ?>_on_disk remove_on_clone"/>
                <input readonly disabled class="<?php echo $class_chain; ?> <?php echo $id; ?>_to_display transform_to_file" type="text" id="<?php echo $id; ?>" data-index="0" name="<?php echo $name; ?>[]" value="<?php echo $value; ?>"/>
                <a href="#" id="<?php echo $id; ?>_change" class='remove_on_clone'><?php echo $labels['CxWpPlugin.message.selectanotherfile'] ;?></a>

			<?php else: ?>
                <input <?php if(@$disabled) echo 'disabled'; ?> class="<?php echo $id; ?> <?php echo $class_chain; ?>" type="file" id="<?php echo $id; ?>" data-index="0" name="<?php echo $name; ?>[]" value="<?php echo $value; ?>" />
			<?php endif; ?>

            <span class="cx2_<?php echo $id ?>-info">
                <?php
                $message= '';
                switch($id):
	                case 'personal-cv':
		                $message = $labels['CxPortal.message.info.allowedTypes'];
		                break;
	                case 'personal-photo':
		                $message = $labels['CxPortal.message.info.allowedImageTypes'];
		                break;
                endswitch;
                echo $message;
                ?>
                <b> (max <?php echo ( Environment_Installation::get_max_file_upload() <= WP_Constants::CARERIX_API_MAX_ATTACHMENT_SIZE_MB ) ? Environment_Installation::get_max_file_upload() : WP_Constants::CARERIX_API_MAX_ATTACHMENT_SIZE_MB; ?> MB) </b>
            </span>

			<?php
			if(strlen(trim($error))>0):
				echo "<div class='error remove_on_clone'>$error</div>";
			endif;
			$disabled = $disabled ? 'disabled' : '';
			$style = 'display: none;';
			if($value) $style = '';
			echo '<a data-index="'.$dataindex.'" href="#" data-remove="'.$id.'" class="derepeat '.$id.' '.$class.'" style="'.$style.'"><i class="fa fa-minus"></i> '.$labels['general.button.remove'].'</a>';
			?>
        </div>

		<?php cx_init_repeatablefile_handle_footer( $id, $name, $value, $class_chain); ?>
	<?php endfor; ?>

<?php else: ?>

    <div class='<?php echo $class; ?>'>
        <label for="<?php echo $id; ?>" class="cx2_<?php echo $id; ?><?php echo $req_class_label; ?>"><?php echo $label; ?></label>
        <input <?php if(@$disabled) echo 'disabled'; ?> class="<?php echo $id; ?> <?php echo $class_chain; ?>" type="file" id="<?php echo $id; ?>" data-index="0" name="<?php echo $name; ?>[]" value="<?php echo $value; ?>" />
        <span class="cx2_<?php echo $id ?>-info">
            <?php
            $message= '';
            switch($id):
	            case 'personal-cv':
		            $message = $labels['CxPortal.message.info.allowedTypes'];
		            break;
	            case 'personal-photo':
		            $message = $labels['CxPortal.message.info.allowedImageTypes'];
		            break;
            endswitch;
            echo $message;
            ?>
            <b> (max <?php echo ( Environment_Installation::get_max_file_upload() <= WP_Constants::CARERIX_API_MAX_ATTACHMENT_SIZE_MB ) ? Environment_Installation::get_max_file_upload() : WP_Constants::CARERIX_API_MAX_ATTACHMENT_SIZE_MB; ?> MB) </b>
        </span>

		<?php
		if(strlen(trim($error))>0):
			echo "<div class='error'>$error</div>";
		endif;
		$disabled = $disabled ? 'disabled' : '';
		$style = 'display: none;';
		if ($value) $style = '';
		echo '<a data-index="'.$dataindex.'" href="#" data-remove="'.$id.'" class="derepeat '.$id.' '.$class.'" style="'.$style.'"><i class="fa fa-minus"></i> '.$labels['general.button.remove'].'</a>';
		?>
    </div>
	<?php
	cx_init_repeatablefile_handle_footer( $id, $name, $value, $class_chain);
	?>

<?php endif; ?>

<?php
    $style ='style="display: none;"';
    if($repeatable && !$disabled && $repeatedItems < 5):
        $style = '';
    endif;
    echo '<a id="cx2_'.$id.'-add" '.$style.' data-index="'.$dataindex.'" href="#" data-repeats="'.$id.'" class="repeat '.$id.' '.$class.'"><i class="fa fa-plus"></i> '.$labels['general.button.add'].'</a>';
    $repeatindex++;
?>

<?php
    return;
?>