<?php

$jobdescription  = $this->data; // injected with: $template->with($content)->display( true );
$jobdescription  = strip_shortcodes($jobdescription);
$pubDate         = get_post_meta(get_the_ID(), 'pubDate', true);
$datePosted      = mysql2date( "Y-m-d", $pubDate );
$endDate         = get_post_meta(get_the_ID(), 'endDate', true) ;
$terms           = get_the_terms( get_the_ID(), 'worklocation' );
$addressLocality = isset($terms[0]->name) ? $terms[0]->name : "";
$terms           = get_the_terms( get_the_ID(), 'country' );
$addressCountry  = isset($terms[0]->name) ? $terms[0]->name : "";
$terms           = get_the_terms( get_the_ID(), 'region' );
$addressRegion   = isset($terms[0]->name) ? $terms[0]->name : "";
$postalCode      = get_post_meta(get_the_ID(), 'postalCode', true);
$company         = get_post_meta(get_the_ID(), 'company', true);
$isAnonymous     = strlen($company)?false:true;
$logo            = "";
$isSalaryPublic  = get_post_meta(get_the_ID(), 'isSalaryPublic', true);
$gfj_status      = Environment_Settings::getGoogleforjobsStatus();
$gfj_da_status   = Environment_Settings::getGoogleforjobsDirectApplyStatus();


if ($isAnonymous) {
	$company = trim(Environment_Settings::getGoogleforjobsOrganization());
	$logo_obj = Environment_Settings::getGoogleforjobsLogoUrl();
	if ( isset($logo_obj) && is_array($logo_obj) && count($logo_obj)) {
	    $logo = $logo_obj[0];
    }
}

$hiring_organization = array (
	'@type' => 'Organization',
	/* 'sameAs' => 'http://www.google.com', */
);
if ( strlen($company) ) $hiring_organization['name'] = $company;
if ( strlen($logo) ) $hiring_organization['logo'] = $logo;

$postalAddress = array (
	'@type' => 'PostalAddress',
	/*'streetAddress' => '1600 Amphitheatre Pkwy',*/
);
if ( strlen($addressLocality) ) $postalAddress['addressLocality'] = $addressLocality;
if ( strlen($addressRegion) ) $postalAddress['addressRegion'] = $addressRegion;
if ( strlen($postalCode) && !$isAnonymous ) $postalAddress['postalCode'] = $postalCode;
if ( strlen($addressCountry) ) $postalAddress['addressCountry'] = $addressCountry;


$gfj = array (
	'@context' => 'https://schema.org/',
	'@type' => 'JobPosting',
	'title' => the_title("", "", false),
	'description' => $jobdescription,
	/* 'identifier' =>
		array (
			'@type' => 'PropertyValue',
			'name' => 'MagsRUs Wheel Company',
			'value' => '1234567',
		), */
	'datePosted' => $datePosted,
	/* 'employmentType' => 'CONTRACTOR', 'FULL_TIME', 'PART_TIME' */
	'hiringOrganization' => $hiring_organization,
	'jobLocation' =>
		array (
			'@type' => 'Place',
			'address' => $postalAddress,
		),
);

/**
 * The salary fields will only be included in the REST API sync mode
 * The deprecated 'cxtools' mode can't fetch this setting and is unable
 * to determine what to do with it.
 */
if ($isSalaryPublic) {
	$currency = get_post_meta(get_the_ID(), 'salaryCurrency', true); // EUR, USD
	$salaryPeriodClassification = strtolower(get_post_meta(get_the_ID(), 'salaryPeriodClassification', true)); // E.g. HourTag, DayTag, WeekTag, MonthTag, YearTag
	switch ($salaryPeriodClassification) {
		case "hourtag":
			$unitText = "HOUR";
			break;
		case "daytag":
			$unitText = "DAY";
			break;
		case "weektag":
			$unitText = "WEEK";
			break;
		case "monthtag":
			$unitText = "MONTH";
			break;
		case "yeartag":
			$unitText = "YEAR";
			break;
		default:
			// Unrecognized classification
			$unitText = "";
	}

	$minSalary = (double) get_post_meta(get_the_ID(), 'minSalary', true);
	$maxSalary = (double) get_post_meta(get_the_ID(), 'maxSalary', true);

	if ($minSalary > 0 && $maxSalary > $minSalary) {
		$salaryQuantification = array(
			'@type' => 'QuantitativeValue',
			'minValue' => $minSalary,
		    'maxValue'=> $maxSalary,
			'unitText' => $unitText,
		);
	} else {
		$singleSalary         = $minSalary + $maxSalary; // One of the operands is zero
		$salaryQuantification = array(
			'@type' => 'QuantitativeValue',
			'value' => $singleSalary,
			'unitText' => $unitText,
		);
	}

	if ( strlen($unitText) ) { // Only include official period classification units
		$gfj['baseSalary'] = array (
			'@type' => 'MonetaryAmount',
			'currency' => $currency,
			'value' => $salaryQuantification,
		);
	}
}

if ( $gfj_da_status == "on") {
	$gfj['directApply'] = true;
}

if ( strlen($endDate) ) {
	$validThrough        = mysql2date("Y-m-d", $endDate . ' -1 day');
	$gfj['validThrough'] = "{$validThrough}T23:59:59";
}

if ($gfj_status == "on") {
	$gfj_json = @json_encode($gfj, JSON_UNESCAPED_SLASHES + JSON_PRETTY_PRINT);
	echo "<script type=\"application/ld+json\">{$gfj_json}</script>";
}